diff --git a/t3lib/js/extjs/ux/ext.ux.plupload.js b/t3lib/js/extjs/ux/ext.ux.plupload.js
new file mode 100644
index 0000000..9155194
--- /dev/null
+++ t3lib/js/extjs/ux/ext.ux.plupload.js
@@ -0,0 +1,422 @@
+/*!
+ * Ext.ux.PluploadPanel
+ * Ext.ux.PluploadButton
+ * (c) http://adtim.ru/extjs/ux_plupload
+ * 2010-04-28 v0.1
+ */
+
+Ext.ux.PluploadPanel = Ext.extend(Ext.Panel, {
+    constructor: function(config) {
+
+        this.autoScroll = false;
+        this.bodyCssClass = 'x-plupload-body';
+
+        this.success = [];
+        this.failed = [];
+
+        this.viewTpl = new Ext.XTemplate(
+            '<tpl for=".">',
+                '<dl id="{id}">',
+                    '<dt style="width: 50%">{name}</dt>',
+                    '<dt style="width: 15%">{size:fileSize}</dt>',
+                    '<tpl exec="this.statusValue(status, percent, msg)"></tpl><dt style="width: 35%">{this.statusText}</dt>',
+                    '<div class="x-clear"></div>',
+                '</dl>',
+            '</tpl>',
+            {   compiled: true,
+                statusText: '-',
+                statusTextQueued: config.statusQueuedText || 'Queued',
+                statusTextUploading: config.statusUploadingText || 'Uploaded ({0}%)',
+                statusTextFailed: config.statusFailedText || 'FAILED',
+                statusTextDone: config.statusDoneText || 'DONE',
+                statusValue: function (status, percent, msg) {
+                    if ( status == 1 ) {
+                        this.statusText = this.statusTextQueued;
+                    }
+                    else if ( status == 2 ) {
+                        this.statusText = String.format( this.statusTextUploading, percent );
+                    }
+                    else if ( status == 4 ) {
+                        this.statusText = msg || this.statusTextFailed;
+                    }
+                    else if ( status == 5 ) {
+                        this.statusText = this.statusTextDone;
+                    }
+                }
+            }
+        );
+
+        this.store = new Ext.data.JsonStore({
+            fields: [ 'id', 'loaded', 'name', 'size', 'percent', 'status', 'msg' ],
+            listeners: {
+                load: this.onStoreLoad,
+                remove: this.onStoreRemove,
+                update: this.onStoreUpdate,
+                scope: this
+            }
+        });
+
+        this.pbar = new Ext.ProgressBar({ flex: 1 });
+
+        this.bbar = new Ext.Toolbar({
+            layout: 'hbox',
+            style: { paddingLeft: '5px' },
+            items: [
+                this.pbar,
+                new Ext.Toolbar.TextItem({
+                    text: '<i>uploader not initialized</i>',
+                    itemId: 'status'
+                })
+            ]
+        });
+    
+        this.tbar = new Ext.Toolbar({
+            enableOverflow: true,
+              items: [
+                new Ext.Button({
+                    text: config.addButtonText || 'Add files',
+                    itemId: 'addButton',
+                    iconCls: config.addButtonCls,
+                    disabled: true
+                }),
+                new Ext.Button({
+                    text: config.uploadButtonText || 'Upload',
+                    handler: this.onStart,
+                    scope: this,
+                    disabled: true,
+                    itemId: 'start',
+                    iconCls: config.uploadButtonCls
+                }),
+                new Ext.Button({
+                    text: config.cancelButtonText || 'Cancel',
+                    handler: this.onCancel,
+                    scope: this,
+                    disabled: true,
+                    itemId: 'cancel',
+                    iconCls: config.cancelButtonCls
+                }),
+                new Ext.SplitButton({
+                    text: config.deleteButtonText || 'Remove',
+                    handler: this.onDeleteSelected,
+                    menu: new Ext.menu.Menu({
+                        items: [
+                            {text: config.deleteSelectedText || '<b>Remove selected</b>', handler: this.onDeleteSelected, scope: this },
+                            '-',
+                            {text: config.deleteUploadedText || 'Remove uploaded', handler: this.onDeleteUploaded, scope: this },
+                            '-',
+                            {text: config.deleteAllText || 'Remove all', handler: this.onDeleteAll, scope: this }
+                        ]
+                    }),
+                    scope: this,
+                    disabled: true,
+                    itemId: 'delete',
+                    iconCls: config.deleteButtonCls
+                })
+            ]
+        });
+
+        this.view = new Ext.DataView({
+            store: this.store,
+            tpl: this.viewTpl,
+            multiSelect: true,
+            overClass: 'plupload_over',
+            selectedClass: 'plupload_selected',
+            itemSelector: 'dl',
+            emptyText: config.emptyText || '<div class="plupload_emptytext"><span>Queue is empty</span></div>',
+            emptyDropText: config.emptyDropText || '<div class="plupload_emptytext"><span>Drop files here</span></div>',
+            deferEmptyText: false,
+            plugins: Ext.DataView.DragSelector ? new Ext.DataView.DragSelector() : ''
+        });
+
+        this.items = this.view;
+
+        Ext.ux.PluploadPanel.superclass.constructor.apply(this, arguments);
+    },
+    initComponent: function() {
+        Ext.ux.PluploadPanel.superclass.initComponent.apply(this, arguments);
+    },
+    afterRender: function() {
+        Ext.ux.PluploadPanel.superclass.afterRender.apply(this, arguments);
+
+        this.initialize_uploader();
+    },
+    onDeleteSelected: function () {
+        Ext.each( this.view.getSelectedRecords(), 
+            function (record) {
+                this.remove_file( record.get( 'id' ) );
+            }, this
+        );
+    },
+    onDeleteAll: function () {
+        this.store.each(
+            function (record) {
+                this.remove_file( record.get( 'id' ) );
+            }, this
+        );
+    },
+    onDeleteUploaded: function () {
+        this.store.each(
+            function (record) {
+                if ( record.get( 'status' ) == 5 ) {
+                    this.remove_file( record.get( 'id' ) );
+                }
+            }, this
+        );
+    },
+    onCancel: function () {
+        this.uploader.stop();
+    },
+    onStart: function () {
+        this.fireEvent('beforestart', this);
+        if ( this.multipart_params ) {
+            this.uploader.settings.multipart_params = this.multipart_params;
+        }
+        this.uploader.start();
+    },
+    initialize_uploader: function () {
+        var runtimes = 'gears,browserplus,html5';
+        if ( this.flash_swf_url ) {
+            runtimes = "flash," + runtimes; 
+        }
+        if ( this.silverlight_xap_url ) {
+            runtimes = "silverlight," + runtimes; 
+        }
+        this.uploader = new plupload.Uploader({
+            url: this.url,
+            runtimes: this.runtimes || runtimes,
+            browse_button: this.getTopToolbar().getComponent('addButton').getEl().dom.id,
+            container: this.getTopToolbar().getEl().dom.id,
+            max_file_size: this.max_file_size || '10mb',
+            resize: this.resize || '',
+            flash_swf_url: this.flash_swf_url || '',
+            silverlight_xap_url: this.silverlight_xap_url || '',
+            filters : this.filters || [],
+            chunk_size: this.chunk_size,
+            unique_names: this.unique_names,
+            multipart: this.multipart,
+            multipart_params: this.multipart_params,
+            file_data_name: this.file_data_name,
+            drop_element: this.body.dom.id,
+            required_features: this.required_features
+        });
+        Ext.each(['Init', 'ChunkUploaded', 'FilesAdded', 'FilesRemoved', 'FileUploaded', 'PostInit',
+                  'QueueChanged', 'Refresh', 'StateChanged', 'UploadFile', 'UploadProgress', 'Error',  ],
+                 function (v) { this.uploader.bind(v, eval("this." + v), this); }, this
+                );
+        this.uploader.init();
+    },
+    remove_file: function (id) {
+        var fileObj = this.uploader.getFile( id );
+        if ( fileObj ) {
+            this.uploader.removeFile( fileObj );
+        }
+        else {
+            this.store.remove( this.store.getById( id ) );
+        }
+    },
+    update_pbar: function () {
+        var t = this.uploader.total;
+        var speed = Ext.util.Format.fileSize(t.bytesPerSec);
+        var total = this.store.data.length;
+        var failed = this.failed.length; 
+        var success = this.success.length;
+        var sent = failed + success;
+        var queued = total - success - failed;
+//console.log('Sent', sent, 'Total', total, 'Success', success, 'Failed', failed, 'Queued', queued, 'Speed', speed);
+        if ( total ) {
+            this.progressText = '';
+            var pbarText = String.format( this.progressText || '{2} of {1} uploaded ({5}/s)', sent, total, success, failed, queued, speed );
+            var percent = t.percent / 100;
+
+            // flash and html4 runtime fix (uploader.total contains outdated info about queue)
+            if ( this.runtime == 'flash' || this.runtime == 'html4' ) { 
+                if ( total == sent || this.store.find('status', /1|2/) == -1 ) { //find queued or uploading status
+                    percent = 1  
+                }
+            }
+            // end fix
+
+            this.pbar.updateProgress(percent, pbarText);
+        }
+        else {
+            this.pbar.updateProgress(0, ' ');
+        }
+    },
+    update_store: function (v) {
+        if ( !v.msg ) { v.msg = ''; }
+        var data = this.store.getById(v.id);
+        if ( data ) {
+            data.data = v;
+            data.commit();
+        }
+        else {
+            this.store.loadData(v, true);
+        }
+    },
+    onStoreLoad: function (store, record, operation) {
+        this.update_pbar();
+    },
+    onStoreRemove: function (store, record, operation) {
+        if ( ! store.data.length ) {
+            this.getTopToolbar().getComponent('delete').setDisabled(true);
+            this.getTopToolbar().getComponent('start').setDisabled(true);
+            this.uploader.total.reset();
+        }
+        var id = record.get( 'id' );
+
+        Ext.each( this.success, 
+            function (v) {
+                if ( v && v.id == id ) {
+                    this.success.remove(v);
+                }
+            }, this
+        );
+
+        Ext.each( this.failed, 
+            function (v) {
+                if ( v && v.id == id ) {
+                    this.failed.remove(v);
+                }
+            }, this
+        );
+        this.update_pbar();
+    },
+    onStoreUpdate: function (store, record, operation) {
+        this.update_pbar();
+    },
+    Init: function(uploader, data) {
+        var bbar = this.getBottomToolbar();
+        var statusCmp = bbar.getComponent('status');
+        this.runtime = data.runtime;
+        if ( this.runtime_visible == true ) {
+            statusCmp.setText(" Uploader runtime: " + this.runtime);
+        }
+        else {
+            statusCmp.setText('');
+        }
+
+        bbar.syncSize();
+
+        if ( this.uploader.features.dragdrop ) {
+            var v = this.view;
+            v.emptyText = this.emptyDropText;
+            if ( v.rendered ) {
+                v.refresh();
+            }
+        }
+        this.getTopToolbar().getComponent('addButton').setDisabled(false);
+    },
+    ChunkUploaded: function() {
+    },
+    FilesAdded: function(uploader, files) {
+        this.getTopToolbar().getComponent('delete').setDisabled(false);
+        this.getTopToolbar().getComponent('start').setDisabled(false);
+        Ext.each(files, 
+            function (v) {
+                this.update_store( v );
+            }, this
+        );
+    },
+    FilesRemoved: function(uploader, files) {
+        Ext.each(files, 
+            function (file) {
+                this.store.remove( this.store.getById( file.id ) );
+            }, this
+        );
+    },
+    FileUploaded: function(uploader, file, status) {
+        var response = Ext.util.JSON.decode( status.response );
+        if ( response.success == true ) {
+            file.server_error = 0;
+            this.success.push(file);
+        }
+        else {
+            if ( response.message ) {
+                file.msg = '<span style="color: red">' + response.message + '</span>';
+            }
+            file.server_error = 1;
+            this.failed.push(file);
+        }
+        this.update_store( file );
+    },
+    PostInit: function() {
+
+    },
+    QueueChanged: function(uploader) {
+    },
+    Refresh: function(uploader) {
+        Ext.each(uploader.files, 
+            function (v) {
+                this.update_store( v );
+            }, this
+        );
+    },
+    StateChanged: function(uploader) {
+        if ( uploader.state == 2 ) {
+            this.fireEvent('uploadstarted', this);
+            this.getTopToolbar().getComponent('cancel').setDisabled(false);
+            this.getTopToolbar().getComponent('start').setDisabled(true);
+        }
+        else {
+            this.fireEvent('uploadcomplete', this, this.success, this.failed);
+            this.getTopToolbar().getComponent('cancel').setDisabled(true);
+            this.getTopToolbar().getComponent('start').setDisabled(false);
+        }
+    },
+    UploadFile: function(uploader, file) {
+        this.fireEvent('uploadfile', this, uploader, file);
+    },
+    UploadProgress: function(uploader, file) {
+        if ( file.server_error ) {
+            file.status = 4;
+        }
+        this.update_store( file );
+    },
+    Error: function (uploader, data) {
+        data.file.status = 4;
+        if ( data.code == -600 ) {
+            data.file.msg = String.format( '<span style="color: red">{0}</span>', this.statusInvalidSizeText || 'Too big' );
+        }
+        else if ( data.code == -700 ) {
+            data.file.msg = String.format( '<span style="color: red">{0}</span>', this.statusInvalidExtensionText || 'Invalid file type' );
+        }
+        else {
+            data.file.msg = String.format( '<span style="color: red">{2} ({0}: {1})</span>', data.code, data.details, data.message );
+        }
+        this.update_store( data.file );
+    }
+});
+
+Ext.reg('pluploadpanel', Ext.ux.PluploadPanel);
+
+Ext.ux.PluploadButton = Ext.extend(Ext.Button, {
+    constructor: function(config) {
+
+        this.uploadpanel = new Ext.ux.PluploadPanel(config.upload_config);
+
+        this.window = new Ext.Window({ 
+            title: config.window_title || config.text || 'Upload files',
+            width: config.window_width || 640, 
+            height: config.window_height || 380, 
+            layout: 'fit', 
+            items: this.uploadpanel, 
+            closeAction: 'hide',
+            listeners: {
+                hide: function (window) {
+                    if ( this.clearOnClose ) {
+                        this.uploadpanel.onDeleteAll();
+                    }
+                },
+                scope: this
+            }
+        });
+
+        this.handler = function () { 
+            this.window.show(); 
+            this.uploadpanel.doLayout();
+        };
+        
+        Ext.ux.PluploadButton.superclass.constructor.apply(this, arguments);
+    }
+});
+Ext.reg('pluploadbutton', Ext.ux.PluploadButton);
diff --git a/tests/t3lib/file/storage/t3lib_file_storage_filesystemstorageTest.php b/tests/t3lib/file/storage/t3lib_file_storage_filesystemstorageTest.php
new file mode 100644
index 0000000..d3225ca
--- /dev/null
+++ tests/t3lib/file/storage/t3lib_file_storage_filesystemstorageTest.php
@@ -0,0 +1,123 @@
+<?php
+
+include_once 'vfsStream/vfsStreamWrapper.php';
+include_once 'vfsStream/vfsStream.php';
+
+class t3lib_file_storage_FileSystemStorageTest extends tx_phpunit_testcase {
+	/**
+	 * @test
+	 */
+	public function basePathAlwaysEndsWithSlash() {
+		$storageConfiguration = array('relative' => TRUE, 'path' => 'relative/path');
+
+		$storageBackend = new t3lib_file_storage_FileSystemStorage($storageConfiguration);
+		$this->assertEquals(PATH_site . $storageConfiguration['path'] . '/', $storageBackend->getBasePath());
+
+		$storageConfiguration = array('relative' => FALSE, 'path' => '/absolute/path');
+
+		$storageBackend = new t3lib_file_storage_FileSystemStorage($storageConfiguration);
+		$this->assertEquals($storageConfiguration['path'] . '/', $storageBackend->getBasePath());
+	}
+
+	/**
+	 * @test
+	 */
+	public function relativePathIsResolvedCorrectly() {
+		$storageConfiguration = array('relative' => 1, 'path' => 'relative/path/');
+
+		$storageBackend = new t3lib_file_storage_FileSystemStorage($storageConfiguration);
+		$this->assertEquals(PATH_site . $storageConfiguration['path'], $storageBackend->getBasePath());
+	}
+
+	/**
+	 * @test
+	 */
+	public function relativePathWithDotsIsResolvedCorrectly() {
+		$storageConfiguration = array('relative' => 1, 'path' => '../a/relative/path/outside/the/typo3/site/directory/');
+
+		$storageBackend = new t3lib_file_storage_FileSystemStorage($storageConfiguration);
+		$expectedPath = substr(PATH_site, 0, strrpos(PATH_site, '/', -2)) . substr($storageConfiguration['path'], strpos($storageConfiguration['path'], '/'));
+		$this->assertEquals($expectedPath, $storageBackend->getBasePath());
+	}
+
+	/**
+	 * @test
+	 */
+	public function copyCopiesFileToCorrectLocation() {
+		$root = vfsStream::setup('root');
+		$subdir = vfsStream::newDirectory('somedir')->at($root);
+		$file = vfsStream::newFile('source.txt')->at($subdir);
+		$storageBackend = new t3lib_file_storage_FileSystemStorage(array('path' => vfsStream::url('root'), 'relative' => FALSE));
+		$storageBackend->copyFile('somedir/source.txt', 'somedir/target.txt');
+
+		$this->assertTrue($subdir->hasChild('target.txt'));
+	}
+
+	/**
+	 * @test
+	 */
+	public function copyThrowsExceptionIfSourceFileIsNotFound() {
+		$this->setExpectedException('InvalidArgumentException');
+
+		$root = vfsStream::setup('root');
+		$subdir = vfsStream::newDirectory('somedir')->at($root);
+		$storageBackend = new t3lib_file_storage_FileSystemStorage(array('path' => vfsStream::url('root'), 'relative' => FALSE));
+		$storageBackend->copyFile('somedir/source.txt', 'somedir/target.txt');
+	}
+
+	/**
+	 * @test
+	 */
+	public function moveFileMovesToCorrectLocation() {
+		$root = vfsStream::setup('root');
+		$subdir = vfsStream::newDirectory('somedir')->at($root);
+		$file = vfsStream::newFile('source.txt')->at($subdir);
+		$storageBackend = new t3lib_file_storage_FileSystemStorage(array('path' => vfsStream::url('root'), 'relative' => FALSE));
+		$storageBackend->moveFile('somedir/source.txt', 'somedir/target.txt');
+
+		$this->assertFalse($subdir->hasChild('source.txt'));
+		$this->assertTrue($subdir->hasChild('target.txt'));
+	}
+
+	/**
+	 * @test
+	 */
+	public function moveFileThrowsExceptionIfSourceFileDoesNotExist() {
+		$this->setExpectedException('InvalidArgumentException');
+
+		$root = vfsStream::setup('root');
+		$subdir = vfsStream::newDirectory('somedir')->at($root);
+		$storageBackend = new t3lib_file_storage_FileSystemStorage(array('path' => vfsStream::url('root'), 'relative' => FALSE));
+		$storageBackend->moveFile('somedir/source.txt', 'somedir/target.txt');
+	}
+
+	/**
+	 * @test
+	 */
+	public function moveFileThrowsExceptionIfDestinationFileExists() {
+		$this->setExpectedException('InvalidArgumentException');
+
+		$root = vfsStream::setup('root');
+		$subdir = vfsStream::newDirectory('somedir')->at($root);
+		vfsStream::newFile('source.txt')->at($subdir);
+		vfsStream::newFile('target.txt')->at($subdir);
+		$storageBackend = new t3lib_file_storage_FileSystemStorage(array('path' => vfsStream::url('root'), 'relative' => FALSE));
+		$storageBackend->moveFile('somedir/source.txt', 'somedir/target.txt');
+	}
+
+	/**
+	 * @test
+	 */
+	public function createDirectoryCreatesDirectory() {
+		$root = vfsStream::setup('root');
+		$storageBackend = new t3lib_file_storage_FileSystemStorage(array('path' => vfsStream::url('root'), 'relative' => FALSE));
+
+		$storageBackend->createDirectory('', 'aDirOnTheFirstLevel');
+		$this->assertTrue($root->hasChild('aDirOnTheFirstLevel'));
+
+		$subdir = vfsStream::newDirectory('someDir')->at($root);
+		$storageBackend->createDirectory('someDir', 'anotherDir');
+
+		$this->assertTrue($subdir->hasChild('anotherDir'));
+	}
+}
\ No newline at end of file
diff --git a/tests/t3lib/file/t3lib_file_fileTest.php b/tests/t3lib/file/t3lib_file_fileTest.php
new file mode 100644
index 0000000..3e04cda
--- /dev/null
+++ tests/t3lib/file/t3lib_file_fileTest.php
@@ -0,0 +1,58 @@
+<?php
+/***************************************************************
+* Copyright notice
+*
+* (c) 2010 Andreas Wolf <andreas.wolf@ikt-werk.de>
+* All rights reserved
+*
+* This script is part of the TYPO3 project. The TYPO3 project is
+* free software; you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation; either version 2 of the License, or
+* (at your option) any later version.
+*
+* The GNU General Public License can be found at
+* http://www.gnu.org/copyleft/gpl.html.
+*
+* This script is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+*
+* This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+/**
+ * Testcase for the t3lib_file_File class in the TYPO3 Core.
+ *
+ * @package TYPO3
+ * @subpackage t3lib
+ *
+ * @author Andreas Wolf <andreas.wolf@ikt-werk.de>
+ */
+class t3lib_file_fileTest extends tx_phpunit_testcase {
+
+	/**
+	 * @test
+	 */
+	public function constructorStoresFileData() {
+		// pseudo file data from the database
+		$fileData = array(
+			'uid' => 1,
+			'file_name' => 'test.jpg',
+			'file_path' => 'just/a/random/testfolder/',
+			'file_size' => 1234,
+			'file_hash' => sha1(uniqid())
+		);
+		$mockMount = $this->getMock('t3lib_file_Mount');
+
+		$fileObject = new t3lib_file_File($mockMount, $fileData);
+
+		$this->assertEquals($fileData['uid'], $fileObject->getUid(), 'File uid was not stored correctly.');
+		$this->assertEquals($fileData['file_name'], $fileObject->getName(), 'File name was not stored correctly.');
+		$this->assertEquals($fileData['file_size'], $fileObject->getSize(), 'File size was not stored correctly.');
+		$this->assertEquals($fileData['file_path'], $fileObject->getPath(), 'Node path was not stored correctly.');
+		$this->assertEquals($fileData['file_hash'], $fileObject->getHash(), 'Node path was not stored correctly.');
+	}
+}
+?>
\ No newline at end of file
diff --git a/tests/t3lib/file/t3lib_file_indexerTest.php b/tests/t3lib/file/t3lib_file_indexerTest.php
new file mode 100644
index 0000000..e9c99ec
--- /dev/null
+++ tests/t3lib/file/t3lib_file_indexerTest.php
@@ -0,0 +1,92 @@
+<?php
+
+class t3lib_file_IndexerTest extends tx_phpunit_testcase {
+
+	private $_dbConnectionBackup;
+
+	/**
+	 * @var t3lib_file_Mount
+	 */
+	private $mockedMount;
+
+	/**
+	 * @var t3lib_file_storage_Interface
+	 */
+	private $mockedStorage;
+
+	/**
+	 * @var t3lib_DB
+	 */
+	private $mockedDatabase;
+
+	public function setUp() {
+		$this->mockedStorage = $this->getMock('t3lib_file_storage_Interface');
+		$this->mockedStorage->expects($this->any())->method('exists')->will($this->returnValue(TRUE));
+		$this->mockedMount = $this->getMock('t3lib_file_Mount');
+		$this->mockedMount->expects($this->any())->method('getUid')->will($this->returnValue(1));
+		$this->mockedMount->expects($this->any())->method('getStorageBackend')->will($this->returnValue($this->mockedStorage));
+
+		$this->mockedDatabase = $this->getMock('t3lib_DB');
+
+		$this->_dbConnectionBackup = $GLOBALS['TYPO3_DB'];
+		$GLOBALS['TYPO3_DB'] = $this->mockedDatabase;
+	}
+
+	public function tearDown() {
+		$GLOBALS['TYPO3_DB'] = $this->_dbConnectionBackup;
+		$this->mockedMount = NULL;
+		$this->mockedStorage = NULL;
+	}
+
+	/**
+	 * @test
+	 */
+	public function indexerCorrectlyResolvesFilePath() {
+		$fakedPath = 'someFolder/' . uniqid() . 'with/someFileInIt_' . uniqid() . '.ext';
+
+		$this->mockedMount->expects($this->any())->method('getStorageBackend')->will($this->returnValue($this->mockedStorage));
+		$this->mockedDatabase->expects($this->any())->method('exec_INSERTquery')->with(
+			$this->anything(),
+			$this->logicalAnd($this->contains(basename($fakedPath)), $this->contains(dirname($fakedPath) . '/'))
+		);
+
+		t3lib_file_Indexer::addFileToIndex($this->mockedMount, $fakedPath);
+	}
+
+	/**
+	 * @test
+	 */
+	public function indexerStoresTimesWithNewFileRecords() {
+		$fakedPath = 'someFolder/' . uniqid() . 'with/someFileInIt_' . uniqid() . '.ext';
+
+		$this->mockedMount->expects($this->any())->method('getStorageBackend')->will($this->returnValue($this->mockedStorage));
+		$this->mockedDatabase->expects($this->any())->method('exec_INSERTquery')->with(
+			$this->anything(),
+			$this->logicalAnd($this->contains($GLOBALS['EXEC_TIME']))
+		);
+
+		t3lib_file_Indexer::addFileToIndex($this->mockedMount, $fakedPath);
+	}
+
+	/**
+	 * @test
+	 */
+	public function indexerQueriesBackendForFileData() {
+		$fakedPath = 'someFolder/' . uniqid() . 'with/someFileInIt_' . uniqid() . '.ext';
+
+		$modificationTime = time();
+		$hash = uniqid();
+		$size = rand(1, 1048576);
+		$this->mockedStorage->expects($this->any())->method('getSize')->will($this->returnValue($size));
+		$this->mockedStorage->expects($this->any())->method('getFileHash')->will($this->returnValue($hash));
+		$this->mockedStorage->expects($this->any())->method('getModificationTime')->will($this->returnValue($modificationTime));
+		$this->mockedMount->expects($this->any())->method('getStorageBackend')->will($this->returnValue($this->mockedStorage));
+
+		$this->mockedDatabase->expects($this->atLeastOnce())->method('exec_INSERTquery')->with(
+			'sys_files',
+			$this->logicalAnd($this->contains($hash), $this->contains($size), $this->contains($modificationTime))
+		);
+
+		t3lib_file_Indexer::addFileToIndex($this->mockedMount, $fakedPath);
+	}
+}
\ No newline at end of file
diff --git a/tests/t3lib/file/t3lib_file_mountTest.php b/tests/t3lib/file/t3lib_file_mountTest.php
new file mode 100644
index 0000000..6e65883
--- /dev/null
+++ tests/t3lib/file/t3lib_file_mountTest.php
@@ -0,0 +1,49 @@
+<?php
+
+class t3lib_file_mountTest extends tx_phpunit_testcase {
+
+	/**
+	 * @test
+	 */
+	public function getInstanceReturnsInstanceForUidZero() {
+		$mountObject = t3lib_file_Mount::getInstanceForUid(0);
+
+		$this->assertType('t3lib_file_Mount', $mountObject);
+	}
+
+	/**
+	 * @test
+	 */
+	public function backendInInstanceForUidZeroPointsToCorrectLocation() {
+		$mountObject = t3lib_file_Mount::getInstanceForUid(0);
+		$backend = $mountObject->getStorageBackend();
+
+		$this->assertEquals(PATH_site . 'fileadmin/', $backend->getBasePath());
+	}
+
+	/**
+	 * @test
+	 */
+	public function getUrlForPathUsesBaseUrlFromBackend() {
+		$baseUrl = 'protocol://some-host/some/path/to/a/mount/';
+		$filePath = 'a/file/inside/the/mount.ext';
+
+		$mountObject = new t3lib_file_Mount();
+		$backendObject = $this->getMock('t3lib_file_storage_filesystemstorage', array('getBaseUrl'));
+		$backendObject->expects($this->any())->method('getBaseUrl')->will($this->returnValue($baseUrl));
+		$mountObject->setStorageBackend($backendObject);
+
+		$this->assertEquals($baseUrl . $filePath, $mountObject->getUrlForPath($filePath));
+	}
+
+	/**
+	 * @test
+	 */
+	public function getInstanceForAliasReturnsCorrectMount() {
+		$mount = t3lib_file_Mount::getInstanceForAlias('fileadmin');
+
+		$this->assertEquals(0, $mount->getUid());
+		$this->assertEquals('fileadmin', $mount->getAlias());
+	}
+}
+?>
\ No newline at end of file
